<template>
  <div class="sign-up">
    <div class="login-header">
      <h6>СОЗДАТЬ АККАУНТ</h6>
      <p>Зарегистрируйте и имейте доступ к информации о Ваших заказах и быстрых покупках.</p>
    </div>
    <div class="single-line-input">
      <div class="form-group">
        <label for="name">ИМЯ</label>
        <input type="text" class="main-input" :class="{'invalid': checkRequired(newUser.firstName)}" v-model="newUser.firstName" name="firstName">
      </div>

      <div class="form-group">
        <label for="name">ФАМИЛИЯ</label>
        <input type="text" class="main-input" :class="{'invalid': checkRequired(newUser.lastName)}" v-model="newUser.lastName" name="lastName">
      </div>
    </div>

    <div class="form-group">
      <label for="name">ТЕЛЕФОН</label>
      <div class="d-flex">
        <span class="phone-code">+380 </span>
        <input type="text" class="main-input mt-1" :class="{'invalid': checkRequired(newUser.phone, 'phone')}" v-model="newUser.phone" name="phone">
      </div>
    </div>

    <div class="form-group">
      <label for="email">EMAIL</label>
      <div>
        <input type="text" class="main-input" :class="{'invalid': checkRequired(newUser.email, 'email')}" v-model="newUser.email" name="email">
      </div>
    </div>

    <div class="single-line-input">
      <div class="form-group">
        <label for="password">ПАРОЛЬ</label>
        <input type="password" class="main-input" :class="{'invalid': checkRequired(newUser.password, 'password')}" v-model="newUser.password" name="password">
      </div>
      <div class="form-group">
        <label for="confirmPassword">ПОВТОРИТЕ ПАРОЛЬ</label>
        <input type="password" class="main-input" :class="{'invalid': checkRequired(newUser.confirmPassword, 'password')}" v-model="newUser.confirmPassword" name="confirmPassword">
      </div>
    </div>

    

    <label class="special-offers"><input type="checkbox" v-model="subscribed"> Получать специальные предложения на почту</label>
    <p class="errorMessage" v-if="error" v-text="error"></p>
    <button class="action-button black-button" @click="signup">СОЗДАТЬ</button>
  </div>
</template>
<script>
import {mapMutations} from 'vuex';
export default {
  data() {
    return {
      error: '',
      subscribed: true,
      newUser: {
        'firstName': '',
        'lastName': '',
        'email': '',
        'phone': '',
        'password': '',
        'confirmPassword': ''
      },
      showRequired: false
    }
  },
  methods: {
    ...mapMutations(["ADD_LOGGED_USER"]),
    checkRequired(i, type) {
      if (type === 'email') {
        return this.showRequired && !i || this.showRequired && !validEmail(i);
      } else if (type === 'phone') {
        return this.showRequired && !i || this.showRequired && !validPhone(i);
      } else if (type === 'password') {
        return this.showRequired && !i || this.showRequired && this.newUser.password.length < 4 || this.showRequired && this.newUser.password !== this.newUser.confirmPassword;
      } else {
        return this.showRequired && !i;
      }
    },
    signup(e) {
      this.error = '';
      this.showRequired = false;

      if (!Object.keys(this.newUser).every(k => this.newUser[k])) {
        this.error = 'Пожалуйста, заполните обязательные поля';
        return this.showRequired = true;
      } else if (!validEmail(this.newUser.email)) {
        this.error = 'Пожалуйста, введите корректный email адрес';
        return this.showRequired = true;
      } else if (!validPhone(this.newUser.phone)) {
        this.error = 'Пожалуйста, введи корректный номер телефона';
        return this.showRequired = true;
      } else if (this.newUser.password.length < 4) {
        this.error = `Пароль должен состоять миним из 4 символов`;
        return this.showRequired = true;
      } else if (!passwordsDontMatch(this.newUser.password, this.newUser.confirmPassword)) {
        this.error = `Пароли не совпадают`;
        return this.showRequired = true;
      }
      e.target.disabled = true;

      return this.$http.post(`${process.env.VUE_APP_BASE_URL}/signup`, this.newUser)
        .then(response => {
          let loginCreds = {
            'email': this.newUser.email,
            'password': this.newUser.password
          };
          return this.$http
            .post(`${process.env.VUE_APP_BASE_URL}/login`, loginCreds)
            .then(response => {
              this.ADD_LOGGED_USER(response.data);
              this.$router.push(this.$route.query.from || "/");
            })
        })
        .catch(error => {
          e.target.disabled = false;
          if (error.response.status === 401) {
            this.error = error.response.data;
          } else {
            this.error = 'Произошла ошибка';
          }
        });
    }
  }
}

function passwordsDontMatch(p1, p2) {
  return p1 === p2;
}

function validPhone(num) {
  num = num.toString();
  let m = num.match(/\d/g); 
  return m && num.length === 9;
}

function validEmail(email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(String(email).toLowerCase());
}


</script>
<style lang="scss">
  .single-line-input {
    display: flex;
    justify-content: space-between;
    & > div:first-child {
      margin-right: 10px;
    }
  }
  .sign-up {
    label {
      font-size: 14px;
      letter-spacing: 1.2px;
    }
    .special-offers {
      letter-spacing: unset;
    }
  }
</style>